/* yasep/VHDL/config.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
2009-05-28 : yasep/tools/generate_VHDL.html created by whygee at f-cpu.org from opcode_map.html
2009-06-06
2009-07-11
2009-07-28 : Y
20090830 : config panel
20090920 : SULV->SLV
dim. févr. 12 06:49:50 CET 2012 : windowed version
dim. févr. 19 09:32:45 CET 2012 : adding valid instructions and such (should be generalised with "profiles")
lun. févr. 20 12:14:17 CET 2012 : profiles almost working
jeu. mai  10 05:17:49 CEST 2012 : moved to VHDL

Purpose : Makes buttons that configure a profile and export the corresponding VHDL definitions

Buggy
 */



init_obj.push(config={
  win: null,

  opcodes_id:[],

// buggy !
  changeInstruction: function(val,instr) {
    if (!config.core)
      wa("VHDL/config#name=empty");
    config.core.valid_instructions[instr]=(val==="true")? 1 : 0;
    config.opcodes_id[instr].checked=val;
  },

  changeAllInstruction: function(b) {
    var val=0, i;
    if(this.id == "enable_all")
      val=1;
    for (i in config.opcodes_id)
      config.changeInstruction(val,i);
  },

// check the configuration sanity
  check: function() {

    switch (config.core.multiplier) {
      case 0:
      case 8:
      case 16: break;
      default : config.core.multiplier=0;
    }

    switch (config.core.datapath) {
      case 16: if (config.core.multiplier==16) config.core.multiplier=8; // constrain the MUL size
      case 32: break;
      default : config.core.datapath=16; config.check(); // recursive (lazy iteration)
    }

    switch (config.core.pipelined) {
      case 0:
      case 1: break;
      default : config.core.pipelined=0;
    }
    getById("mul"+config.core.multiplier).checked=true;
    getById("size"+config.core.datapath).checked=true;
    getById("pipe"+config.core.pipelined).checked=true;
  },

//////////////////////// generate the file ////////////////////////
  emit_VHDL: function(){
    config.check();
    var f, i, n, t, j, index, instr, vhdl=generated("--","VHDL/config.js")
+'-- Profile name : '+config.profile_name+'\n'
+'\n'
+'Library ieee;\n'
+'    use ieee.std_logic_1164.all;\n'
+'    use ieee.numeric_std.all;\n'
+'\n'
+'package yasep_definitions is\n'
+'----------------------------------------------------------\n'
+'-- user defined values :\n'
+'  constant YASEP_SIZE : natural := '+config.core.datapath+';\n'
+'  constant YASEP_MUL  : natural := '+config.core.multiplier+';\n'
+'  constant PIPELINED  : natural := '+config.core.pipelined+';\n'
+'  constant PC_LENGTH  : natural := ',
        valid_instructions=[],
        noWriteBack=[],
        noCondition=[],
        abortWrite=[],
        IgnoreSND=[],
        IgnoreSI4=[],
        IgnoreImm16=[],
        ChangeCarry=[],
        ChangeZero=[];

    if (typeof config.core.PC_length =="number")
      vhdl+=config.core.PC_length;
    else
      vhdl+='YASEP_SIZE';

    vhdl+=';\n\n'
+'----------------------------------------------------------\n'
+'-- exported from the JavaScript definitions :\n\n'
+'  subtype SLV2   is std_logic_vector( 1 downto 0);\n'
+'  subtype SLV3   is std_logic_vector( 2 downto 0);\n'
+'  subtype SLV4   is std_logic_vector( 3 downto 0);\n'
+'  subtype SLV6   is std_logic_vector( 5 downto 0);\n'
+'  subtype SLV8   is std_logic_vector( 7 downto 0);\n'
+'  subtype SLV16  is std_logic_vector(15 downto 0);\n'
+'  subtype SLV32  is std_logic_vector(31 downto 0);\n'
+'  subtype SLVr64 is std_logic_vector(0 to 63);\n'
+'  subtype SLVY   is std_logic_vector(YASEP_SIZE-1 downto 0);\n'
+'  subtype SLVAI  is std_logic_vector(PC_LENGTH-1 downto 1);\n\n';

    function collapse(a) {
      for (var i=0; i<64; i++)
        if (typeof a[i]!="number")
          a[i]=0;
      return a.join("");
    }

    for (i=0; i<16; i++) {
      t=Y.registers_names[i];
      vhdl+='  constant REG_'+t;
      j=t.length; while (j<4) { j++; vhdl+=' '; }
      vhdl+=': SLV4 := "'+toBin(i,4)+'";\n';
    }
    vhdl+='\n';

    for (var line=0; line<32; line+=4) { // group number
      t=Y.GroupNames[line];
      if (typeof t=="string") {
        vhdl+="  constant "+t;
        i=t.length; while (i<10) { i++; vhdl+=' '; }
        vhdl+=' : SLV3 :=    "'+toBin(line>>2,3)+'";\n';
      }
      for (var col=0; col<8; col++) {
        index=line|(col<<5);
        instr=Y.opcode_table[index];
        if (typeof instr == 'object') {
          n=instr.name;
          i=index>>2;
          f=instr.flags;
          if (config.core.valid_instructions[n]===1) {
            valid_instructions[i]=1;
            if(f & Y.NO_WRITEBACK) noWriteBack[i]=1;
            if(f & Y.NO_CONDITION) noCondition[i]=1;
            if(f & Y.ABORT_WRITE)  abortWrite[i]=1;
            if(f & Y.IGNORE_SND)   IgnoreSND[i]=1;
            if(f & Y.IGNORE_SI4)   IgnoreSI4[i]=1;
            if(f & Y.IGNORE_IMM16) IgnoreImm16[i]=1;
            if(f & Y.CHANGE_CARRY) ChangeCarry[i]=1;
            if(f & Y.CHANGE_ZERO)  ChangeZero[i]=1;
          }

          vhdl+='  constant Op_'+n;
          f=n.length; while (f<7) { f++; vhdl+=' '; }
          vhdl+=' : SLV6 := "'+toBin(i,6)+'";'
               +'  constant F_'+n;
          f=n.length; while (f<6) { f++; vhdl+=' '; }
          vhdl+=' : SLV3 := "'+toBin(i>>3,3)+'";';
          if (config.core.valid_instructions[n]!==1)
            vhdl+=' -- disabled' ;
          vhdl+='\n';
        }
      }
      vhdl+='\n';
    }

    vhdl+='\n-- Flags :\n'
+    '  constant FlagValidInstruction : SLVr64 := "'+collapse(valid_instructions)
// Export the valid_instructions field in hexa, for incorporating
// later in the profiles collection of core-js/yasep_config.js:
+'";\n-- Compacted mask: '+encodeInstructionMask(collapse(valid_instructions))
+ ';\n  constant FlagNoWriteBack      : SLVr64 := "'+collapse(noWriteBack)
+'";\n  constant FlagNoCondition      : SLVr64 := "'+collapse(noCondition)
+'";\n  constant FlagAbortWrite       : SLVr64 := "'+collapse(abortWrite)
+'";\n  constant FlagIgnoreSND        : SLVr64 := "'+collapse(IgnoreSND)
+'";\n  constant FlagIgnoreSI4        : SLVr64 := "'+collapse(IgnoreSI4)
+'";\n  constant FlagIgnoreImm16      : SLVr64 := "'+collapse(IgnoreImm16)
+'";\n  constant FlagChangeCarry      : SLVr64 := "'+collapse(ChangeCarry)
+'";\n  constant FlagChangeZero       : SLVr64 := "'+collapse(ChangeZero)
+'";\n'
+'end yasep_definitions;\n'
+'\n'
+'package body yasep_definitions is\n'
+'  -- empty\n'
+'end yasep_definitions;\n';

    savefile.save("yasep_def.vhdl", vhdl);
  },

  // change to the core type of the name provided in s
  trigger: function(s) {
    if (s=="")
      return;

    var i,u,v;

    s=s.split(',');

    for (i in s){
      u=s[i].split("=");
      if (u.length==2) {
        v=u[0];
        if (v=="name")
          config.change_profile(u[1]);
        else
          if (typeof config.core[v]=="number")
            config.core[v]=+u[1];
      }
    }

    config.check();
  },

  change_profile: function(a) {
    if(typeof a!="string")
      a=this.value;  // when called from clicking on a button
    if (typeof profiles[a] != "object")
      return Al8N("Ipn");
    config.core=profiles[a];
    config.profile_id.innerHTML
     =config.profile_id.source
      =config.profile_name
       =a;

    // List of opcodes to enable/disable
    var i, line, t, h="", col, instr;
    for (line=0; line<32; line+=4) { // group number
      t=Y.GroupNames[line];
      if (typeof t=="string")
        h+="<br>Group "+t+" : &nbsp; ";
      for (col=0; col<8; col++) {
        instr=Y.opcode_table[line|(col<<5)];
        if (typeof instr == 'object') {
          i=instr.name;
          h+='<input type="checkbox" onchange="config.changeInstruction(this.value,\''+i+'\')" ';
          if (config.core.valid_instructions[i]===1)
            h+="checked ";
          h+='value="'+i+'">'+Y.decorate_opcode(i)+' &nbsp ';
        }
      }
    }
    getById("profile_desc","span",config.cont).innerHTML=config.core.comment;    
    config.enable_opcode_id.innerHTML=h;
    config.check();
    t=config.enable_opcode_id.getElementsByTagName("input");
    for (i in t)
      config.opcodes_id[t[i].value]=t[i];  
  },

  list_profiles: function(){
    var d=getById("profiles_list","div",config.cont),
        b, p;
    d.innerHTML=" <u><b>/!\\</b></u> buggy ! "; // empty the div
    for (p in profiles) {
      b=dcE("INPUT");
      b.type="submit";
      b.value=p;
      b.onclick=config.change_profile;
      d.appendChild(b);
    }
  },

  start: function() {
    config.cont=dcE("DIV");
    config.cont.innerHTML=import_htmi("VHDL/config");
    winman.patchInnerLinks(config.cont);
    var enable_opcode_id, h=getByClass("hiddenDiv","DIV",config.cont);
    config.win = ygwm.new_window(
       hiddenText(0,h), null, config.cont,
       450, 450, 80, 80, false, true, true, true, false, "WinOK");

    getById("mul0"  ,"input",config.cont).onchange=function(){ config.core.multiplier=0;  config.check();};
    getById("mul8"  ,"input",config.cont).onchange=function(){ config.core.multiplier=8;  config.check();};
    getById("mul16" ,"input",config.cont).onchange=function(){ config.core.multiplier=16; config.check();};
    getById("size16","input",config.cont).onchange=function(){ config.core.datapath=16;   config.check();};
    getById("size32","input",config.cont).onchange=function(){ config.core.datapath=32;   config.check();};
    getById("pipe0" ,"input",config.cont).onchange=function(){ config.core.pipelined=0;   config.check();};
    getById("pipe1" ,"input",config.cont).onchange=function(){ config.core.pipelined=1;   config.check();};
    getById("save_V","button",config.cont).onclick=config.emit_VHDL;

//    config.saveToJs=getById("save_Profile","button",config.cont);
    config.profile_id=getById("profile_name","span",config.cont);
    config.enable_opcode_id=getById("enable_opcode","div",config.cont);
    config.change_profile("empty");

    getById("enable_all" ,"button",config.cont).onclick=
    getById("disable_all","button",config.cont).onclick=config.changeAllInstruction;
    config.list_profiles();

    edit_text.register(config.profile_id, { size:30, maxsize:30,
       defaultValue: "NewProfile",
       func: function(t){
         config.profile_name=t.source;
         profiles[t.source]=config.core;
         config.list_profiles();
       },
       check: edit_text.filter_alpha });

    config.win.trigger=config.trigger;
    return config.win;
  },

  init_obj: function(){
    config.menuItem = menu.subMenuItem(menu.list["Tools"],i8n.cc, "VHDL/config");
  }
});
