/*
  tool/EU.js : test_eu rebooted
recreated 20120905
contains code from... oh, 2009-07-28 and before
*/

init_obj.push(EU={
//  win:null, unused these days
//  size: 0, // force refresh  // MUST be done in start()
    // so it refreshes every time the window is reopened

//  group_counter:0;
  group_delay:null,
  number_delay:null,

  update_group:function(){
    var g=EU.grp[EU.group_counter++],i,j,
        k=EU.ops[g], l,
        S=EU.S;
    for (i in k) {
      j=k[i];
      l=j.id;

      S.zero=null;
      S.carry=null;
      S.result=null;
      if (EU.size==16)
        Y.opcode_table[j.i].action16(S);
      else
        Y.opcode_table[j.i].action32(S);

      l.innerHTML=int2hex(S.result);

      if (S.carry!=null) {
        l=l.nextSibling;
        l.innerHTML=S.carry;
        // assert: zero is modified only by instructions that change the carry too
        if (S.zero!=null) {
          l.nextSibling.innerHTML=S.zero;
        }
      }
    }

    if (EU.group_counter<EU.grp.length)
      EU.group_delay=setTimeout(EU.update_group,1);
  },

  update: function(){
    // update and check the input data
    var S=EU.S;
    S.ptr_in=EU.mask_ptr & _str2int(EU.ptr_id.value);
    S.snd = EU.mask_data & _str2int(EU.snd_id.value);
    S.si4 = EU.mask_data & _str2int(EU.si4_id.value);
    EU.ptr_id.value=int2hex(S.ptr_in);
    EU.snd_id.value=int2hex(S.snd);
    EU.si4_id.value=int2hex(S.si4);
    EU.S=S;

    // start the update of the columns
    EU.group_counter=0;
    clearTimeout(EU.group_delay);
    EU.group_delay=setTimeout(EU.update_group,1);
  },

  buildResults: function(){    
    var g,h,i,j,
        k= EU.results.firstChild,
        tb,tr,td,
        tb2,tr2,td2;
    if(k)
      EU.results.removeChild(k);

    (tb2=dcE("TABLE")).className="maingroups";
      tr2=dcE("TR");

      for (g in EU.grp) {
        td2=dcE("TD");
          h=EU.grp[g];
          (tb=dcE("TABLE")).className="regs";
           tb.cellspacing="0";

            tr=dcE("TR");
              (td=dcE("TD")).innerHTML=Y.GroupNames[h];
               td.className="head";
               td.colSpan="4";
            tr.appendChild(td);
          tb.appendChild(tr);

            tr=dcE("TR");
              (td=dcE("TD")).innerHTML="Opc.";
            tr.appendChild(td);
              (td=dcE("TD")).innerHTML=I8N("res");
            tr.appendChild(td);
              (td=dcE("TD")).innerHTML="C";
            tr.appendChild(td);
              (td=dcE("TD")).innerHTML="Z";
            tr.appendChild(td);
          tb.appendChild(tr);

          k=EU.ops[h];
          for (i in k) {
            j=k[i];

            tr=dcE("TR");
              (td=dcE("TD")).innerHTML
                    =Y.decorate_opcode(Y.opcode_table[j.i].name)+":";
               td.className="CQ";
              tr.appendChild(td);
              (td=dcE("TD")).innerHTML="u";
               td.className="CQ";
               k[i].id=td;
              tr.appendChild(td);
              (td=dcE("TD")).className="CQ";
              tr.appendChild(td);
              (td=dcE("TD")).className="CQ";
              tr.appendChild(td);
            tb.appendChild(tr);
          }

          td2.appendChild(tb);
        tr2.appendChild(td2);
      }
    tb2.appendChild(tr2);
    EU.results.appendChild(tb2);

    EU.update();
   },

  init16: function(){
    if (EU.size!=16){
        EU.size= 16;
      EU.button_size.innerHTML=hiddenText(1,EU.h);
      EU.mask_ptr=1;
      EU.mask_data=F4;
      EU.grp=EU.grp16;
      EU.ops=EU.ops16;
      EU.buildResults();
    }
  },

  init32: function(){
    if (EU.size!=32){
        EU.size= 32;
      EU.button_size.innerHTML=hiddenText(2,EU.h);
      EU.mask_ptr=3;
      EU.mask_data=F8;
      EU.grp=EU.grp32;
      EU.ops=EU.ops32;
      EU.buildResults();
    }
  },

  trigger: function(size){
    size=+size; // in case it's a string
    switch(size){
      case 16: return EU.init16();
      case 32: return EU.init32();
      default: Al8N("","#!doc/EU : '","",size,"Wds");
    }
  },

  check:function(e){
    if ((e.which || e.keyCode)==13) // Enter ?
      EU.update();
    return true;
  },

  start: function() {
    EU.size= 32; // anything but not 16
// Prepare the operation arrays
    if (!EU.grp16){
      var ops16=[], ops32=[],
          grp16=[], grp32=[], i, g;

      for (i in Y.opcode_table) {
        g = i & Y.FIELD_GROUP; // extract the group number

        // 16-bits part
        if (typeof Y.opcode_table[i].action16 == "function") {
          if (!ops16[g]){ // if the group is not yet registered
            ops16[g]=[];  // create a new group
            grp16.push(g);// and add it to a list of groups
          }
          ops16[g].push({i:i});// Add the instr. number to the sublist
        }

        // 32-bits part
        if (typeof Y.opcode_table[i].action32 == "function") {
          if (!ops32[g]){
            ops32[g]=[];
            grp32.push(g);
          }
          ops32[g].push({i:i});
        }
      }

      EU.grp32=grp32;
      EU.ops32=ops32;
      EU.grp16=grp16;
      EU.ops16=ops16;
    }

    var cont=dcE("DIV");
    cont.innerHTML=import_htmi("tool/EU");
    winman.patchInnerLinks(cont);
    var h
         =EU.h
         =getByClass("hiddenDiv","DIV",cont),
        win
         =EU.win
         =ygwm.new_window(
            hiddenText(0,h), null, cont,
            680, 420, 20, 50, false, true, true, true, false, "docStyle");

    function createText(size, val, func){
      var inp=dcE("INPUT");
      inp.type="text";
      inp.value=val;
      inp.maxLength
        =inp.size
        =size;
      inp.onkeyup=EU.check;
      inp.onblur=EU.update;
      return inp;
    }

    function createButton(val, func){
      var bt=dcE("BUTTON");
      bt.innerHTML=val;
      bt.onclick=func;
      return bt;
    }

    function inc_val(id, inc) {
      return function()  {    // closure
        id.value=int2hex(_str2int(id.value)  + inc);
        EU.update();
      }
    }

// Builds the control panel
    var tb, tr,td;
    (tb=dcE("TABLE")).className="control";
      tr=dcE("TR");
        (td=dcE("TD")).innerHTML=hiddenText(3,h);
        tr.appendChild(td);
        (td=dcE("TD")).style.textAlign="left";
          td.appendChild(EU.ptr_id=createText(3,"1"));
        tr.appendChild(td);
        (td=dcE("TD")).appendChild(createButton(" + ",inc_val(EU.ptr_id,1)));
        tr.appendChild(td);
        (td=dcE("TD")).appendChild(createButton(" - ",inc_val(EU.ptr_id,-1)));
        tr.appendChild(td);
      tb.appendChild(tr);

      tr=dcE("TR");
        (td=dcE("TD")).innerHTML=hiddenText(4,h);
        tr.appendChild(td);
        (td=dcE("TD")).appendChild(EU.snd_id=createText(12,"1234h"));
        tr.appendChild(td);
        (td=dcE("TD")).appendChild(createButton(" + ",inc_val(EU.snd_id,1)));
        tr.appendChild(td);
        (td=dcE("TD")).appendChild(createButton(" - ",inc_val(EU.snd_id,-1)));
        tr.appendChild(td);
      tb.appendChild(tr);

      tr=dcE("TR");
        (td=dcE("TD")).innerHTML=hiddenText(5,h);
        tr.appendChild(td);
        (td=dcE("TD")).appendChild(EU.si4_id=createText(12,"5678h"));
        tr.appendChild(td);
        (td=dcE("TD")).appendChild(createButton(" + ",inc_val(EU.si4_id,1)));
        tr.appendChild(td);
        (td=dcE("TD")).appendChild(createButton(" - ",inc_val(EU.si4_id,-1)));
        tr.appendChild(td);

        (td=dcE("TD")).appendChild(
         EU.button_size=createButton("_",function(){
          if(EU.size==16)
             EU.init32();
          else
             EU.init16();
        }));
        tr.appendChild(td);

      tb.appendChild(tr);
    cont.appendChild(tb);

    cont.appendChild(EU.results=dcE("DIV")); // Will be filled by the table of results
    win.trigger=EU.trigger;

    EU.S=Y.opcodeInterface(function(a,b){
      win.shortmsg(b);
      setTimeout(win.erase_msg,2000);
    });

    EU.init16(); // update everything now
    return win;
  },

  init_obj: function(){
    menu.subMenuItem(menu.list["Tools"],i8n.EU, "doc/EU");
  }
});
